
#define V121_STRG13 "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_"
#define V121_STRG14 " ./\;:!@#$%^&*()=+-"
#define V121_STRG15 "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_ ./\;:!@#$%^&*()=+-"
#define V121_STRG16 "0123456789-"
#define V121_STRG17 "        "
#define V121_STRG18 "        "
#define V121_STRG19 "PIE"
#define V121_STRG20 "Type GCS To Start\n"
#define V121_STRG21 "dopcbat.dat"
#define V121_STRG22 "dopcbat.dat"
#define V121_STRG23 ""
#define V121_STRG24 ""
#define V121_STRG25 ""
#define V121_STRG26 "c:\\P3DGCS"
#define V121_STRG435 "GCS World File Version 0.5\0\x1A\xD6"
#define V121_STRG436 "rb"
#define V121_STRG437 "Problem"
#define V121_STRG438 "Invalid File Format"
#define V121_STRG439 "%d %d %s %s \n"
#define V121_STRG440 ".DAT"
#define V121_STRG441 "    "

#define info_window 40,100,280,335,palmatch[menubg],palmatch[menufg]

#include "stdio.h"
#include "string.h"
#include "math.h"
#include "stdlib.h"
#include "dos.h"
#include "dir.h"
#include "io.h"
#include "alloc.h"
#include "fgfonts.h"
#include "process.h"

struct fg_vport {
	int sx1,sy1,sx2,sy2;   /* screen coordinates for viewport */
	double x1,y1,x2,y2;    /* world coordinates for viewport */
	int background,border; /* background and border colors */
	} fg_viewports[2];


int palmatch[128];
unsigned char grid_on=0;
char path_to_library[30];
char path_to_palette[30];
char guard_files[50];  /* path to guard files */
char weapon_files[50]; /* path to weapon files */
char working_path[30];
char path_to_file[30];
char working_file[9];
char alpha[]=V121_STRG13;
/* char space[]=V121_STRG14; */
char alpha_space[]=V121_STRG15;
char num_only[]=V121_STRG16;


//typedef struct theatre_entry {
//	char level_name[9];
//	char description[30];
//	int levnum;
//	int x,y,z,rotation;
//	} theaters;

struct pal {
	char r;
	char g;
	char b;
	};

/*
struct fluid {
       int species,x,y,z,rot;
       char fnum[3];
       char obj[13]; object for frame
       int cmd,parm;
       char command[22]; };  */

struct object_def {
	short int species;
	int handle;
	int xdim,ydim;
	char filename[13];
	char lib_name[9];
	unsigned char bytes_reqd;
	} pie_objects[600],obj_db,obj_temp;

int current_object=0;

struct world_def {
	short int species;
	short int index_to_handle; /* NOT the handle, but the index */
	int x,y,z;
	int rotation;
	unsigned int attrib;
	unsigned int opval1,opval2,opval3,opval4;
	} world_objects[701];

struct fluid_info {
	short int species;
	int x,y,z,rotation,command,wait,frame_ref;
	char filename[13]; /* object file name and path */
	char pathname[30];
	char edit_str[30];
	int xdim,ydim;
	} fld[40];

int player_x=0,player_y=0;
int *selobj,numsel=0;
int num_objects=2,num_entities=0;
int use_floor=0,use_ceiling=0;
int vpbg,vpborder,menufg,menubg,entity_color;
int gsnapstat=1;
int gsnapres=400;
int pbx=0,pby=0;
int bld_fld=0;
int bld_cf=0;
int last_object=-1;
char fld_str[13];
int fld_xdim,fld_ydim;
int osnap=1;
long unsigned int pie_memleft=164000;
extern unsigned _stklen=22000U;

int dontdrawback=0,dontfade=0,univchange=0,sink=0,dontdrawfar=0,dontbump=0;
int frill=0,noradar=0,notake=0,robobit=0,isdoor=0,moving=0;
int attrib=0,opval1=0,opval2=0,opval3=0,opval4=0;

char directory[]=V121_STRG17;
char shortname[30];
char db_shortname[9];
char cur_db[13];
char cur_pal[13];
char music_file[]=V121_STRG18;
char cur_tbl[13];
int cur_level=40;
int modified=0;  // was anything modified, if not don't ask to save!

int gox=0,goy=0;   /* global grid offset x,y variables */



void load_world(worldname)
char *worldname;
{
FILE *fp;
char temppal[13];
char header[]=V121_STRG435;
char header2[29];
char temp[30];
int count;
struct object_def *po;
struct world_def *wo;


fp=fopen(worldname,V121_STRG436);
if(fp==NULL) {
  printf("\n Error, could not open: %s", worldname); exit(1);
}
fread(&header2[0],29,1,fp);
if (strcmp(header,header2)!=0) {
	printf("\n");
	printf(V121_STRG438);
	printf("\n");
	fclose(fp);
	exit(1); }

puts(header);
num_objects=getw(fp);
printf("numobj %d\n",num_objects);
fread(pie_objects,sizeof(obj_db),num_objects,fp);
if (pie_objects[0].species==22) { use_floor=0; use_ceiling=0; } else use_floor=1;
printf("useflr %d\n",use_floor);
printf("useclg %d\n",use_ceiling);
if (pie_objects[1].species==22) use_ceiling=0; else use_ceiling=1;
num_entities=getw(fp);
printf("nument %d\n",num_entities);
fread(world_objects,sizeof(world_objects[0]),num_entities,fp);
player_x=getw(fp);
printf("Playrx %d\n",player_x);
player_y=getw(fp);
printf("Playry %d\n",player_y);
cur_level=getw(fp);
printf("curlev %d\n",cur_level);
fread(music_file,9,1,fp);
puts(music_file);
fread(palmatch,256,1,fp);
fread(&fg_viewports[0],sizeof(fg_viewports[0]),1,fp);
fread(path_to_palette,30,1,fp);
printf("palpath %s\n",path_to_palette);
fread(path_to_library,30,1,fp);
printf("libpath %s\n",path_to_library);
fread(guard_files,30,1,fp);
printf("grdpath %s\n",guard_files);
fread(weapon_files,30,1,fp);
printf("weppath %s\n",weapon_files);
fread(cur_pal,13,1,fp);
printf("curpal %s\n",cur_pal);
fread(cur_db,13,1,fp);
printf("cur_db %s\n",cur_db);
if (!feof(fp)) fread(&pie_memleft,4,1,fp);
printf("memlft %lu\n",pie_memleft); 
if (!feof(fp)) {
dontdrawback=getw(fp);
printf("dntdrb %d\n",dontdrawback); 
if (feof(fp)) dontdrawback=0; else {
dontfade=getw(fp);
printf("dntfde %d\n",dontfade); 
dontdrawfar=getw(fp);
printf("dntdrf %d\n",dontdrawfar); 
dontbump=getw(fp);
printf("dntbmp %d\n",dontbump); 
frill=getw(fp);
printf("ffrill %d\n",frill); 
sink=(frill>=256);
if (frill>0) frill=1;
printf("frill  %d\n",frill); 
noradar=getw(fp);
printf("noradr %d\n",noradar); 
osnap=getw(fp);
printf("osnap  %d\n",osnap); 
gsnapstat=getw(fp); 
printf("gsnpst %d\n",gsnapstat); 
}}
fclose(fp);
printf("pieobj %d\n",num_objects); 
for (count=0;count<num_objects;count++) {
  po=&pie_objects[count];
  printf("%6d %6d %5u %5u \"%12s\" \"%8s\" %5u\n",
     po->species, po->handle, po->xdim, po->ydim,
     po->filename, po->lib_name, po->bytes_reqd);
}
for (count=0;count<num_entities;count++)  {
  wo=&world_objects[count];
  printf("%1u %3u %6d %6d %6d %6d %04X %5u %5u %5u %5u\n",
  wo->species,wo->index_to_handle,wo->x, wo->y, wo->z,
  wo->rotation, wo->attrib, wo->opval1, wo->opval2, wo->opval3, wo->opval4);
}
}

int main(int argc, char **argv) {

	if(argc<2) {
		printf("\n barfwrld foo.wld\n");
                exit(1);
	}
	load_world(argv[1]);
	exit(0);
}

